#include			<stdio.h>
#include			<stdlib.h>
#include			<alloc.h>
#include			<float.h>
#include			<math.h>
#include			<string.h>
#include			<time.h>
#include			"my_menu.h"
#include			"adeshdef.h"
#include			"adeshve.h"
#include			"desh_gen.h"
#include			"deshgrph.h"
#include			"desh_gb.h"


int	menu_GB(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
		int i;
		char temp[50];
		VN_Menu GB_Items;

			if(Init_VN_Menu(&GB_Items, "Main/Compute/GB Menus", 4, 4) == VN_MENU_ERROR)
				{
					printf("\n Can not create Main/Compute/GB Menu ");
					get_key_press();
					return(VN_MENU_EXIT);
				}

			sprintf(temp, "Boundary Angle : %7.4f", GB_Angle);
			Init_VN_Menu_Entry(&GB_Items, 1, temp, Input_GB_Param);
			sprintf(temp, "Core Width : %7.4f", GB_Core_Width);
			Init_VN_Menu_Entry(&GB_Items, 2, temp, Input_GB_Param);
			Init_VN_Menu_Entry(&GB_Items, 3, "Make GB", Make_GB);
			Init_VN_Menu_Entry(&GB_Items, 4, "Reconstruct GB Core", Make_GB_Core);

			i=Handle_VN_Menu(&GB_Items, 1);
			Close_VN_Menu(&GB_Items);
	 return(VN_MENU_EXIT);
	}


int	Input_GB_Param(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
	 char temp[50];


	 if(VN_Menu_Entry == 1)
		{
			printf("\n Boundary Angle = ? ");
			GB_Angle = get_float(GB_Angle);
			sprintf(temp, "Boundary Angle = %7.4f",GB_Angle);
			Change_VN_Menu_Entry(VN_Menu_Name, VN_Menu_Entry, temp);
		}
	 if(VN_Menu_Entry == 2)
		{
			printf("\n Core Width Angle = ? ");
			GB_Core_Width = get_float(GB_Core_Width);
			sprintf(temp, "Core Width = %7.4f",GB_Core_Width);
			Change_VN_Menu_Entry(VN_Menu_Name, VN_Menu_Entry, temp);
		}
	 return(VN_MENU_CONTINUE);
	}

int	Make_GB(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
	 int i, GB_Atoms;
	 double angle;
	 float cos_angle, sin_angle;
	 float x_new, y_new;
	 struct atom_specs *gb_atom_ptr;
	 if(Total_Atoms < 1)
		{
			printf("\n No cell created or read in\n\n");
			printf(" Hit ant key to continue ....");
			i=get_key_press();
			return(VN_MENU_CONTINUE);
		}

		File_Modification = DESH_YES;
	 angle = (double)GB_Angle * PI / 180.;
	 angle = 0.5 * angle;
	 cos_angle = (float) cos (angle);
	 sin_angle = (float) sin (angle);
	 gb_atom_ptr = atom_ptr_temp;
	 atom_ptr = atom_ptr_temp;
	 i=0;
	 GB_Atoms = 0;
	 while(i < Total_Atoms)
		 {
			 x_new = atom_ptr->XC * cos_angle -
				 atom_ptr->YC * sin_angle;
			 y_new = atom_ptr->YC * cos_angle +
				 atom_ptr->XC * sin_angle;
			 if( x_new <= GB_Core_Width/2.0)
				{
		gb_atom_ptr->XC = x_new;
		gb_atom_ptr->YC = y_new;
		gb_atom_ptr->ZC = atom_ptr->ZC;
		gb_atom_ptr->TYPE = atom_ptr->TYPE;
		gb_atom_ptr->PLANE = atom_ptr->PLANE;
		GB_Atoms++;
		gb_atom_ptr++;
				}
			i++;
			atom_ptr++;
		 }
	 atom_ptr = atom_ptr_temp;
	 i=0;
	 Total_Atoms = GB_Atoms;
	 while(i < GB_Atoms)
		{
			if(atom_ptr->XC < -GB_Core_Width/2.0)
			 {
		gb_atom_ptr->XC = -atom_ptr->XC;
		gb_atom_ptr->YC = atom_ptr->YC;
		gb_atom_ptr->ZC = atom_ptr->ZC;
		gb_atom_ptr->TYPE = atom_ptr->TYPE;
		gb_atom_ptr->PLANE = atom_ptr->PLANE;
		Total_Atoms++;
		gb_atom_ptr++;
			 }
	 atom_ptr++;
	 i++;
	 }
	 printf("\n\nGrain boundary constructed\nHit any key to continue ....");
	 GB_Constructed = DESH_YES;
	 i=get_key_press();
	 return(VN_MENU_CONTINUE);
	}


